/////////////////////////////////////////////////////////////////////////////////////
// Katax Emperore  -- web3D sample  --
// Web3D + JavaScript programming by using three.js
// for more samples and details, please check my home page-->   www.kataxwork.com
/////////////////////////////////////////////////////////////////////////// 2017 ////

function Cube() {
    var geometry 		        = new THREE.BoxBufferGeometry( 20, 20, 20 );
    var CubeTexture 	        = new THREE.Texture();
    var loader 			        = new THREE.ImageLoader();

    loader.load( 'images/crate.gif', function(image){
        CubeTexture.image       = image;
        CubeTexture.needsUpdate = true;
    }          );

    var CubeMaterial 	        = new THREE.MeshPhongMaterial();
    CubeMaterial.map 	        = CubeTexture;

    this.CubeMesh 	            = new THREE.Mesh(geometry, CubeMaterial);
    this.CubeMesh.name 	        = 'object_00';

}

///////////////////// control functions ////////////////////////////////////
Cube.prototype.AddObject =          function (area){
    area.add(this.CubeMesh);
}

///////////////////// coordination functions ///////////////////////////////
Cube.prototype.setCoordinations =   function (x, y, z) {
    this.CubeMesh.position.set(x, y, z);
}

Cube.prototype.getCoordinations =   function () {
    var position = new THREE.Vector3();
    return ( position.setFromMatrixPosition( this.CubeMesh.matrixWorld ) );
}

///////////////////// scalar values functions ///////////////////////////////
Cube.prototype.setScale =           function (x, y, z) {
    this.CubeMesh.scale.set(x, y, z);
}

///////////////////// helper functions /////////////////////////////////////
Cube.prototype.setName =            function (name){
    this.CubeMesh.name  = name;
}

Cube.prototype.getName =            function (){
    return this.CubeMesh.name;
}
;
