/////////////////////////////////////////////////////////////////////////////////////
// Katax Emperore  -- web3D sample  --
// Web3D + JavaScript programming by using three.js
// for more samples and details, please check my home page-->   www.kataxwork.com
/////////////////////////////////////////////////////////////////////////// 2017 ////

function Shapes() {
	this.shape_name = ["circle", "landa_horizonal", "cross", "landa_vertical", "star" ]; // shape names
	// element coordinations per shape
	this.coordinations_X = [
	[   4,   8,   1,  11,   0,  12,   1,  11,   4,   8],
	[   0,  12,   9,   0,   6,  12,   3,   9,   0,  12],
	[   6,   6,   1,   3,   6,   9,  11,   6,   6,   6],
	[   3,   6,   9,   4,   6,   4,   8,   3,   6,   9],
	[   6,   0,   4,   8,  12,   3,   9,   6,   1,  11]
	];
	
	this.coordinations_Y = [
	[   0,   0,   2,   2,   6,   6,  10,  10,  12,  12],
	[   3,   3,   4,   6,   6,   6,   8,   8,   9,   9],
	[   0,   2,   5,   5,   5,   5,   5,   8,  10,  12],
	[   0,   0,   0,   3,   6,   9,   9,  12,  12,  12],
	[   0,   4,   4,   4,   4,   7,   7,   9,  12,  12]
	];
	this.maxNumberObjects = 10;		// maximim elements on stage
}

///////////////////// coordination functions ///////////////////////////////
Shapes.prototype.getCoordX = function (name) {		// get array of X coordination for specific shape by name
	var result = [];
	var iterator = -1;
	for (var i = 0; i < this.shape_name.length; i++){
		if (  this.shape_name[i] == name ) { iterator = i; }
	}
	if ( iterator >= 0 ) result = (this.coordinations_X[iterator]).slice();
	return result;
}

Shapes.prototype.getX = function (name, i) {		// get X of specific shape by name and element by number
    var result = (this.getCoordX(name)).slice();
    return result[i];
}

Shapes.prototype.getCoordY = function (name) {		// get array of Y coordination for specific shape by name
	var result = [];
	var iterator = -1;
	for (var i = 0; i < this.shape_name.length; i++){
		if ( this.shape_name[i] == name ) { iterator = i; }
	}
	if ( iterator >= 0 ) result = (this.coordinations_Y[iterator]).slice();
	return result;
}

Shapes.prototype.getY = function (name, i) {		// get Y of specific shape by name and element by number
	var result = (this.getCoordY(name)).slice();
	return result[i];
}

///////////////////// scalar values functions ///////////////////////////////
Shapes.prototype.setScaleMultiplier = function (name, sc) {			// rescale by shape name
    var iterator = 0;
	for (var i = 0; i < this.shape_name.length; i++){
        if ( this.shape_name[i] == name ) { 	iterator = i; 	}
    }

    if ( sc != 0 ) {
        for (var j = 0; j < this.coordinations_X[iterator].length; j++){
            this.coordinations_X[iterator][j] *= sc;
            this.coordinations_Y[iterator][j] *= sc;
        }
    }
}
Shapes.prototype.setShiftPositions = function (name, x, y, z) {		// repositioning by shape name
    var iterator = 0;
	for (var i = 0; i < this.shape_name.length; i++){
        if ( this.shape_name[i] == name ) { 	iterator = i; 	}
    }

    if ( x != 0 ) {
        for (var j = 0; j < this.coordinations_X[iterator].length; j++) 	this.coordinations_X[iterator][j] += x;
	}
    if ( y != 0 ) {
        for (var m = 0; m < this.coordinations_Y[iterator].length; m++) 	this.coordinations_Y[iterator][m] += y;
    }

}

///////////////////// helper functions /////////////////////////////////////
Shapes.prototype.getMaxObjects = function() { return this.maxNumberObjects; }
Shapes.prototype.getShapeNames = function() { return this.shape_name.slice(); }

;